Index: /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/Entity.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/Entity.cs	(revision 544)
+++ /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/Entity.cs	(revision 544)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.CEDMA.DB.Interfaces;
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.CEDMA.DB.Interfaces {
+  [DataContract]
+  public class Entity : Resource {
+
+    public Entity(string uri) {
+      this.Uri = uri;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/HeuristicLab.CEDMA.DB.Interfaces.csproj
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/HeuristicLab.CEDMA.DB.Interfaces.csproj	(revision 543)
+++ /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/HeuristicLab.CEDMA.DB.Interfaces.csproj	(revision 544)
@@ -55,4 +55,10 @@
   <ItemGroup>
     <Compile Include="AgentEntry.cs" />
+    <Compile Include="SerializedLiteral.cs" />
+    <Compile Include="Literal.cs" />
+    <Compile Include="Entity.cs" />
+    <Compile Include="Resource.cs" />
+    <Compile Include="Statement.cs" />
+    <Compile Include="IStore.cs" />
     <Compile Include="OperatorEntry.cs" />
     <Compile Include="ProcessStatus.cs" />
Index: /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/IStore.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/IStore.cs	(revision 544)
+++ /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/IStore.cs	(revision 544)
@@ -0,0 +1,39 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.ServiceModel;
+using System.Data;
+using System.Linq.Expressions;
+
+namespace HeuristicLab.CEDMA.DB.Interfaces {
+  [ServiceContract(Namespace = "http://HeuristicLab.CEDMA.DB")]
+  public interface IStore {
+    [OperationContract]
+    void Add(Statement statement);
+
+    [OperationContract]
+    IList<Statement> Select(Statement template);
+  }
+}
Index: /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/Literal.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/Literal.cs	(revision 544)
+++ /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/Literal.cs	(revision 544)
@@ -0,0 +1,39 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.CEDMA.DB.Interfaces;
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.CEDMA.DB.Interfaces {
+  [DataContract]
+  public class Literal: Resource {
+    [DataMember]
+    public object Value { get; set; }
+
+    public Literal(object value) {
+      Value = value;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/Resource.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/Resource.cs	(revision 544)
+++ /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/Resource.cs	(revision 544)
@@ -0,0 +1,35 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.CEDMA.DB.Interfaces;
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.CEDMA.DB.Interfaces {
+  [DataContract]  
+  public abstract class Resource {
+    [DataMember]
+    public string Uri { get; set; }
+  }
+}
Index: /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/SerializedLiteral.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/SerializedLiteral.cs	(revision 544)
+++ /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/SerializedLiteral.cs	(revision 544)
@@ -0,0 +1,39 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.CEDMA.DB.Interfaces;
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.CEDMA.DB.Interfaces {
+  [DataContract]
+  public class SerializedLiteral: Resource {
+    [DataMember]
+    public string RawData { get; set; }
+
+    public SerializedLiteral(string rawData) {
+      RawData = rawData;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/Statement.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/Statement.cs	(revision 544)
+++ /trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/Statement.cs	(revision 544)
@@ -0,0 +1,48 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.CEDMA.DB.Interfaces;
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.CEDMA.DB.Interfaces {
+  [DataContract]
+  [KnownType(typeof(Literal))]
+  [KnownType(typeof(Entity))]
+  [KnownType(typeof(SerializedLiteral))]
+  public class Statement {
+    [DataMember]
+    public Entity Subject { get; set; }
+    [DataMember]
+    public Entity Predicate { get; set; }
+    [DataMember]
+    public Resource Property { get; set; }
+
+    public Statement(Entity subj, Entity pred, Resource prop) {
+      Subject = subj;
+      Predicate = pred;
+      Property = prop;
+    }
+  }
+}